

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   DEVIL Screensaver System 1.03                                 *
    *   Copyright  2005 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under LGPL.                      *
    *   See LGPL.txt for details.                        2005-08-31   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


#ifndef POOL_H
#define POOL_H


#include "DevilGlobal.h"


struct Stimu
{
	UINT x;
	UINT y;
	BYTE age;
	BYTE intensity;

	Stimu * next;
};


struct Particle
{
	char    iHeight;
	double  fSpeed;
};


class Pool
{
	UINT uWidth;
	UINT uHeight;
	BITMAPINFO bmi;
	RGBTRIPLE * image;

	UINT uParticleCount;
	Particle * waterplane[ 2 ];
	bool bWhichPlane;
	double fSinusSeed;
	UINT uStimus;
	Stimu * first;

	void CreateStimu( Stimu * out, Stimu * next );
	void AddStimu();
	void StepStimus();
	void StepPlane();
	void UpdateImage( bool bRefreshAll );

public:
	Pool();
	~Pool();

	BITMAPINFO * GetImageInfo() { return &bmi; }
	BYTE * GetImage() { return ( BYTE * )image; }
	UINT GetImageWidth() { return uWidth; }
	UINT GetImageHeight() { return uHeight; }

	void NextFrame();
};



#endif // POOL_H
